

#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <map>
#include <vector>
#include <set>
#include <stack>

#define FILE_STATUS "status.txt"	//  
#define FILE_TABLE "table.txt"		//  


#define ACC 65536	//  
#define FLAG_R 1024 //  

//#define GR_COUNT 6 //  
//char *gr[]={"EE+T","ET","TT*F","TF","F(E)","Fi"};
//char char_set[]="+*()i$ETF";
//char *follow[]={"+)$","+)$","+*)$","+*)$","+*)$","+*)$"};


#define GR_COUNT 14 //  
char *gr[]={
	"BB#E",
	"BB&E",
	"BE",
	"EE+T",
	"EE-T",
	"ET",
	"TT*F",
	"TT/F",
	"TT%F",
	"TF",
	"FF^S",
	"FS",
	"S(B)",
	"Si"};
char char_set[]="BSETF+-* /%()^#&i$";
char *follow[]={
"#&)$", // BB#E
"#&)$", // BB&E
"#&)$", // BE
"#&+-)$", // EE+T
"#&+-)$", // EE-T
"#&+-)$", // ET
"#&+-*/%)$", // TT*F
"#&+-*/%)$", // TT/F
"#&+-*/%)$", // TT%F
"#&+-*/%)$", // TF
"#&+-*/%)^$", // FF^S
"#&+-*/%)^$", // FS
"#&+-*/%)^$", // S(B)
"#&+-*/%)^$"  // Si
};

char test_line[]="i+i^i*i^(i-i/i%i%(i^(i+i)))$";
//char test_line[]="i^i$";

class xy_st{
public:
	int x; int y;
	xy_st() {x=y=0;}
	xy_st(int xx,int yy) {x=xx; y=yy;}
	xy_st(const xy_st&);
};

// -
class Status {
public:
	std::set<xy_st>xy_arr; //  
	Status();
	Status(int line,int num);
	Status(const Status&);
	void AddItem(int,int);	//     
	bool Compare(Status*); //     
	bool CheckSym(int sym); //    
	void Dump(FILE *file); //   
	int isFinal(); //      
};


std::multimap<xy_st,int>first_set; // first   
std::map<xy_st,int>table; //  
typedef std::multimap<xy_st,int>::iterator first_it; // 
std::vector<Status>m_array; //   

//============  xy_st
xy_st::xy_st(const xy_st&obj)
{
	x=obj.x;  y=obj.y;
}

bool operator <(const xy_st&obj1,const xy_st&obj2)
{
	return obj1.x==obj2.x && obj1.y<obj2.y || obj1.x<obj2.x;
}

bool operator ==(const xy_st&obj1,const xy_st&obj2)
{
	return obj1.x==obj2.x && obj1.y==obj2.y;
}

bool operator !=(const xy_st&obj1,const xy_st&obj2)
{
	return obj1.x!=obj2.x || obj1.y!=obj2.y;
}

//===========  Status
Status::Status()
{
}

Status::Status(int line,int num)
{
	AddItem(line,num);
}

Status::Status(const Status& obj)
{
	xy_arr=obj.xy_arr;
}

void Status::AddItem(int line,int num)
{
	xy_st item(line,num);
	xy_arr.insert(item);
}

//  
bool Status::CheckSym(int sym)
{
	int line,num; xy_st ln; first_it it1,it2;
	std::set<xy_st>::iterator it; xy_st item;
	std::set<xy_st>new_arr; 
	for(it=xy_arr.begin(); it!=xy_arr.end(); it++) 
	{
		line=(it)->x;
		num=(it)->y;
		if(gr[line][num+1]==sym) {
			item.x=line; item.y=num+1;
			new_arr.insert(item);
		}
		ln.x=gr[line][num+1];
		ln.y=sym;
		it1=first_set.equal_range(ln).first;
		it2=first_set.equal_range(ln).second;
		while(it1!=it2) {
			item.x=(*it1).second; item.y=1;
			new_arr.insert(item); it1++;
		}
	}
	if(!new_arr.size())return false;
	xy_arr=new_arr;
	return true;
}

int Status::isFinal() //     
{
	std::set<xy_st>::iterator it; int line,num;
	for(it=xy_arr.begin(); it!=xy_arr.end(); it++) {
		line=(it)->x;
		num=(it)->y;
		if(!gr[line][num+1]) return line;
	}
	return -1;
}


//    
void Status::Dump(FILE *file)
{
	int n,num,line;
	std::set<xy_st>::iterator it;
	for(it=xy_arr.begin(); it!=xy_arr.end(); it++) {
	line=(it)->x; num=(it)->y;
	fprintf(file,"  ");
	for(n=0; n<strlen(gr[line]); n++) {
		fputc(gr[line][n],file); 
		if(!n) fputc(' ',file);
		if(n==num) fputc('.',file);
	}
	if(n==num) fputc('.',file);
	fputc('\n',file);
	}
}

//   
bool Status::Compare(Status *obj)
{
	std::set<xy_st>::iterator it1,it2;
	it1=xy_arr.begin(); it2=obj->xy_arr.begin();
	for(;;) {
		if(it1==xy_arr.end() && it2==obj->xy_arr.end()) break;
		if(it1==xy_arr.end() || it2==obj->xy_arr.end()) return false;
		if(*(it1)!=*(it2)) return false;
		it1++; it2++;
	}
	return true;
}

//=====  
//    
void TableAdd(int x,int y,int z)
{
	xy_st item(x,y);
	std::map<xy_st,int>::iterator it;
	it=table.find(item);
	if(it!=table.end() && z!=(it)->second && (it)->second!=ACC) 
		printf("already def [%d,%c] %d<%d\n\a",x,y,(it)->second,z);
	table.insert(std::make_pair(item,z));
}

//  
int AddStatus(Status item)
{
	int n;
	for(n=0; n<m_array.size(); n++) {
		if(m_array[n].Compare(&item)) return n;
	}
	n=m_array.size();
	m_array.push_back(item);
	return n;
}

//      
void WorkStatus(int index)
{
	int n,m; xy_st go;
	Status item=m_array[index];
	for(n=0; char_set[n]; n++) {
		if(item.CheckSym(char_set[n])) {
			m=AddStatus(item);
			TableAdd(index,char_set[n],m);
			item=m_array[index];
		}
	}
}

//     
void Dump()
{
	int n;
	FILE *file=fopen("status.txt","wt");
	for(n=0; n<m_array.size(); n++) {
		fprintf(file,"\n%d:\n",n);
		m_array[n].Dump(file);
	}
	fclose(file);
}

//    
void DumpTable()
{
	FILE *file=fopen("table.txt","wt"); if(!file) return;
	int n,m,r; xy_st item;
	for(m=0; char_set[m]; m++) fprintf(file,"|%c",char_set[m]); fputc('\n',file);
	for(n=0; n<m_array.size(); n++) {
		fprintf(file,"%d",n);
		for(m=0; char_set[m]; m++) {
			item.x=n; item.y=char_set[m];
			std::map<xy_st,int>::iterator it=table.find(item);
			if(it==table.end()) fprintf(file,"|");
			else {
				r=(it)->second;
				if(r==ACC) fprintf(file,"|ACC");
				else if(r>=FLAG_R) fprintf(file,"|R%d",r-FLAG_R);
				else fprintf(file,"|%d",r);
			}
		}
		fputc('\n',file);
	}
	fclose(file);
}

//  first   
void MakeExFirst(int from_sym,int to_sym)
{
	int n; xy_st ln;
	for(n=0; n<GR_COUNT; n++) {
		if(gr[n][0]!=to_sym) continue;
		ln.x=from_sym;
		ln.y=gr[n][1];
		first_it it1=first_set.equal_range(ln).first;
		first_it it2=first_set.equal_range(ln).second;
		while(it1!=it2) {
			if((*it1).second==n) break; 
			it1++;
		}
		if(it1==it2) {
			first_set.insert(std::make_pair(ln,n));
			MakeExFirst(from_sym,ln.y);
		}
	}
}

//    
void MakeTable()
{
	int n,m,l;
	for(n=0; char_set[n]; n++) MakeExFirst(char_set[n],char_set[n]);
	first_it it=first_set.begin();
	while(it!=first_set.end()) {
		printf("(%c,%c,%d)\n",(it)->first.x,(it)->first.y,(it)->second);
		it++;
	}
	Status st; 
	for(n=0; n<GR_COUNT; n++) if(gr[n][0]==gr[0][0]) st.AddItem(n,0);
	m_array.push_back(st);
	for(n=0;n<m_array.size();n++) WorkStatus(n); //   
	for(n=0;n<m_array.size();n++) { //   
		st=m_array[n];
		l=st.isFinal(); if(l<0) continue;
		if(gr[l][0]==gr[0][0]) TableAdd(n,'$',ACC);
		for(m=0; follow[l][m]; m++) TableAdd(n,follow[l][m],FLAG_R+l);
	}
	Dump();
	DumpTable();
}

//=============  
//int GetTok(char sym)
//{
//	char *ref=strchr(char_set,sym); if(!ref) return -1;
//	return ref-char_set;
//}

int GetTable(int x,int y)
{
	xy_st item(x,y);
	std::map<xy_st,int>::iterator it=table.find(item);
	if(it==table.end()) return -1;
	return (it)->second;
}


//  
void Parser()
{
	std::stack<int>Stack; xy_st item;
	int status=0; int n,m,sym;
	int read_index=0;
	Stack.push(0);
	printf("Parsing !\n");
	for(;;) {
//		sym=GetTok(test_line[read_index]);
		sym=test_line[read_index];
		printf("status [%d]\n",status);
		printf("sym [%c]\n",sym);
		n=GetTable(status,sym);
		if(n<0) {
			MessageBox(0,"error2",0,0); exit(0);
		}
		if(n==ACC) {MessageBox(0,"ok","ok",0); break;}
		if(!(n&FLAG_R)) {
			printf("move [%c]\n",sym); read_index++;
			status=n; Stack.push(sym); Stack.push(status); continue;}
		n=n&~FLAG_R;
		printf("R[%d]\n",n);
		for(m=strlen(gr[n])-1; m; m--) {
			Stack.pop(); if(gr[n][m]!=Stack.top()) { MessageBox(0,"err1",0,0); exit(0);}
			Stack.pop();
		}
		status=Stack.top();
		n=gr[n][0];
		status=GetTable(status,n);
		Stack.push(n);
		Stack.push(status);
	}
}

void main()
{
	for(int n=0; n<GR_COUNT; n++) printf("%c: %s\n",gr[n][0],&gr[n][1]);
	MakeTable();
	Parser();
}


